<?php
declare(strict_types=1);

namespace Catequil\Barcode\Handler;

use Laminas\Diactoros\Request;
use Laminas\Diactoros\Response;
use Laminas\Diactoros\Stream;
use Laminas\Diactoros\StreamFactory;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;

/**
 * Class RenderBarcode
 *
 * @package Catequil\Barcode\Handler
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/catequil-barcode
 */
final class RenderBarcode extends AbstractHandler
{
    public function handle(ServerRequestInterface $request): ResponseInterface
    {
        $image = $this->barcodes->generate(
            $request->getAttribute('value')
        );

        return (new Response())
            ->withHeader('Content-Type', 'image/png')
            ->withBody(
                (new StreamFactory())->createStream($image)
            );
    }
}