<?php
declare(strict_types=1);

namespace Catequil\Barcode\Handler;

use Catequil\Core\Exception\NotFoundException;
use Laminas\Diactoros\Response\JsonResponse;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;

/**
 * Class ResolveBarcode
 *
 * @package Catequil\Barcode\Handler
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/catequil-barcode
 */
final class ResolveBarcode extends AbstractHandler
{
    public function handle(ServerRequestInterface $request): ResponseInterface
    {
        return new JsonResponse(
            $this->barcodes->resolve(
                $request->getAttribute('type'),
                $request->getAttribute('barcode')
            )
        );
    }
}