<?php
declare(strict_types=1);

namespace Catequil\Barcode\Model;

use Catequil\Barcode\Repository\BarcodeRepository;
use Doctrine\DBAL\Types\Types;
use Doctrine\ORM\Mapping\Column;
use Doctrine\ORM\Mapping\Entity;
use Doctrine\ORM\Mapping\GeneratedValue;
use Doctrine\ORM\Mapping\Id;
use Doctrine\ORM\Mapping\Index;
use Doctrine\ORM\Mapping\Table;

/**
 * Class Barcode
 *
 * @package Catequil\Barcode\Model
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/catequil-barcode
 */
#[Entity(BarcodeRepository::class)]
#[Table('barcode', options: ['collate' => 'utf8mb4_croatian_ci'])]
#[Index(fields: ['sku'], name: 'sku_idx')]
class Barcode implements BarcodeInterface
{
    //<editor-fold desc="Entity Fields">

    #[Id]
    #[GeneratedValue('AUTO')]
    #[Column(type: Types::BIGINT, options: ['unsigned' => true])]
    protected int $id;
    #[Column(type: Types::STRING, length: 191, unique: true)]
    protected string $barcode;
    #[Column(type: Types::STRING, length: 191)]
    protected string $sku;

    //</editor-fold>
    //<editor-fold desc="Getters & Setters">

    public function getId(): int
    {
        return $this->id;
    }

    public function getBarcode(): string
    {
        return $this->barcode;
    }

    public function setBarcode(string $barcode): void
    {
        $this->barcode = $barcode;
    }

    public function getSku(): string
    {
        return $this->sku;
    }

    public function setSku(string $sku): void
    {
        $this->sku = $sku;
    }

    //</editor-fold>
}
