<?php
declare(strict_types=1);

namespace Catequil\Barcode\Resolver;

use Laminas\ServiceManager\AbstractFactory\ReflectionBasedAbstractFactory;
use Laminas\ServiceManager\AbstractPluginManager;

/**
 * Class ResolverPluginManager
 *
 * @package Catequil\Barcode\Resolver
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/catequil-barcode
 *
 * @method ResolverInterface get(string $name);
 */
final class ResolverPluginManager extends AbstractPluginManager
{
    protected $instanceOf = ResolverInterface::class;

    public function __construct($configInstanceOrParentLocator = null, array $config = [])
    {
        parent::__construct($configInstanceOrParentLocator, $config);

        $this->configure([
            'abstract_factories' => [
                ReflectionBasedAbstractFactory::class,
            ],
        ]);
    }
}