<?php
declare(strict_types=1);

namespace Catequil\Barcode\Resolver;

use Catequil\Barcode\Service\BarcodeService;
use Laminas\ServiceManager\Factory\FactoryInterface;
use Psr\Container\ContainerInterface;

/**
 * Class ResolverPluginManagerFactory
 *
 * @package Catequil\Barcode\Resolver
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/catequil-barcode
 */
final class ResolverPluginManagerFactory implements FactoryInterface
{
    public function __invoke(ContainerInterface $container, $requestedName, ?array $options = null): ResolverPluginManager
    {
        $config = $container->get('config')[BarcodeService::class] ?? [];

        return new ResolverPluginManager($container, [
            'aliases' => $config['resolvers'] ?? [],
        ]);
    }
}